   Program

!Program written by Jeff Slarve
!2012-01-12 in Clarion6.3
!For "decoding" Clarion XLOG files

!2012-01-13 Moved to C8.


    map
      OpenFile(<String pFileName>)
      ReadFileToString(String pFileName,*String pString),Long !Generic func from my library
      FromB64(String pText),String                            !Mini wrapper for John G's function
      Include('cwb64.inc')                                    !C++ Source for BASE64 encoding, by John Griffiths http://sqlkey.com/base64encode.htm
    end

!FILE:queue QUEUE,PRE(File),TYPE
!name        STRING(FILE:MAXFILENAME)  !FILE:MAXFILENAME is an EQUATE
!shortname   STRING(13)
!date        LONG
!time        LONG
!size        LONG
!attrib      BYTE   !A bitmap, the same as the attributes EQUATEs
!          END

   
XLogQ QUEUE(FILE:Queue),PRE(XL)
      END

ExceptionQ QUEUE
ExText CSTRING(512)
           END

CurrentClarionVersion BYTE(7)
Clarion7Path STRING(File:MaxFilePath)
Clarion8Path STRING(File:MaxFilePath)
StatusText   STRING(FILE:MaxFilePath)

XLOGText   String(1000000)   !Shoot me. I didn't make this a dynamic string. It's for holding the contents of the xlog file so it can be manipulated
ResultText String(30000)     !OMG. This one isn't dynamic either. If there's a gigantic XLOG file, we're in trouble. Somebody fix this!

Window WINDOW('XLOG Viewer'),AT(,,522,371),GRAY,IMM,SYSTEM,MAX,ICON('ZOOM.ICO'), |
            FONT('MS Sans Serif',8,,FONT:regular),DROPID('~FILE'),RESIZE
        MENUBAR,USE(?MENUBAR1)
            MENU('&File'),USE(?File)
                ITEM('&Open'),USE(?FileOpen)
                ITEM(''),SEPARATOR,USE(?SEPARATOR1)
                ITEM('E&xit'),USE(?FileExit),STD(STD:Close)
            END
            MENU('&Help'),USE(?Help)
                ITEM('&About'),USE(?HelpAbout)
            END
        END
        TEXT,AT(3,189,517,165),USE(ResultText),BOXED,VSCROLL,FONT('Courier New', |
                8,,FONT:regular,CHARSET:ANSI),COLOR(COLOR:BTNFACE),READONLY
        BUTTON('(Re)Load'),AT(2,6),USE(?btnReload)
        SHEET,AT(3,24,517,161),USE(?SHEET1)
            TAB('XLogs'),USE(?TAB1)
                LIST,AT(11,46,499,130),USE(?LIST1),FROM(XL:name),FORMAT('256L(2)|M2X|')
            END
            TAB('Exceptions to address'),USE(?TAB2),HIDE
                LIST,AT(11,46,499,110),USE(?LIST2),FROM(ExceptionQ)
            END
        END
        OPTION,AT(75,3,162,18),USE(CurrentClarionVersion)
            RADIO(' Clarion 7'),AT(94,8),USE(?CURRENTCLARIONVERSION:RADIO1),VALUE('7')
            RADIO(' Clarion 8'),AT(170,8),USE(?CURRENTCLARIONVERSION:RADIO2),VALUE('8')
        END
        STRING(@S255),AT(247,7,263,12),USE(StatusText),TRN
        BUTTON('Delete selected XLog'),AT(247,24),USE(?BtnDelete)
    END

TempName CString(File:MaxFilePath+1)
ClarionPath STRING(File:MaxFilePath)

   Code

  !get clarion versions from registry
  Clarion7Path= CLIP(GETREG(REG_LOCAL_MACHINE,'Software\SoftVelocity\Clarion7','Root')) & '\bin\'
 
  Clarion8Path= CLIP(GETREG(REG_LOCAL_MACHINE,'Software\SoftVelocity\Clarion8','Root')) & '\bin\'

  Open(Window)

  TempName = Command(1) !For Mark Riffy
  If TempName           !Ditto :)
     OpenFile(TempName)
  else
     !directory to build browse
     DO LoadXLogQ
     !alert dupes
  end

  Accept
    Case Event()
    of Event:Accepted
      Case Field()
      of ?FileOpen
        CLEAR(StatusText)
        OpenFile
      of ?HelpAbout
        Message('Log Viewer 1.1||- No warranty at all -||Source Code Available at Clarionmag.com||By Jeff Slarve')
      OF ?btnReload
         CLEAR(StatusText)
         do LoadXLogQ
      OF ?btnDelete
         SETCURSOR(CURSOR:Wait)
         GET(XLogQ,CHOICE(?LIST1))
         CASE CurrentClarionVersion
            OF 8                       
               Remove(CLIP(Clarion8Path) & '\' & CLIP(XLogQ.Name))
            OF 7
               Remove(CLIP(Clarion7Path) & '\' & CLIP(XLogQ.Name))
         END 
         StatusText = 'Deleted ' & CLIP(Clarion8Path) & '\' & CLIP(XLogQ.Name) & '.'  
         DELETE(XLogQ) 
         display(?StatusText)
         POST(EVENT:NewSelection,?LIST1)
         SETCURSOR()
      end
    of Event:Drop
      OpenFile(DropID())
    of Event:sized
      ?ResultText{PROP:Width} = 0{PROP:Width} - 6
      ?ResultText{PROP:Height} = 0{PROP:Height} - 6
    end

    CASE FIELD()       
       OF ?LIST1
          CASE EVENT()
             OF EVENT:Selected
                ! pre-edit code for field1
             OF EVENT:NewSelection
                GET(XLogQ,CHOICE(?LIST1))     
                CASE CurrentClarionVersion
                   OF 8                       
                      OpenFile(CLIP(Clarion8Path) & CLIP(XLogQ.Name))
                   OF 7
                      OpenFile(CLIP(Clarion7Path) & CLIP(XLogQ.Name))
                END
             OF EVENT:Accepted
                ! completion code for field1
          END
    end

  end

LoadXLogQ ROUTINE

     FREE(XLogQ)

     CASE CurrentClarionVersion
        OF 8          
           DIRECTORY(XLogQ, CLIP(Clarion8Path) & '*.XLog', ff_:NORMAL)
           IF RECORDS(XLogQ) = 0 
              StatusText = 'There are no XLogs for Clarion 8.'
           else
              SORT(XLogQ,XLogQ.name)
           end
        else
           DIRECTORY(XLogQ, CLIP(Clarion7Path) & '*.XLog', ff_:NORMAL)
           IF RECORDS(XLogQ) = 0 
              MESSAGE('There are no XLogs for Clarion 7, switching to Clarion8')
              SELECT(?CURRENTCLARIONVERSION:RADIO2)
              CurrentClarionVersion = 8
              DISPLAY
              DIRECTORY(XLogQ, CLIP(Clarion8Path) & '*.XLog', ff_:NORMAL)
              IF RECORDS(XLogQ) = 0 
                 StatusText = 'There are no XLogs for Clarion 7 or 8.'
              else
                 SORT(XLogQ,XLogQ.name)
              end
           ELSE
              SORT(XLogQ,XLogQ.name)
           end
     END

!=============================================================================================================================================================
OpenFile  Procedure(<String pFileName>)
!=============================================================================================================================================================
FileName  String(File:MaxFilePath)

  Code

  If Omitted(pFileName)
    If NOT FileDialog('Open .XLOG',FileName,'XLOG Files|*.XLOG',File:LongName+File:KeepDir)
      Return
    end
  else
    FileName = pFileName
  end
  If NOT ReadFileToString(FileName,XLogText)
    Message('Error Reading File, Name=' & CLIP(pFileName))
    Return
  end
  !The first 24 bytes of the file probably mean something in some combination of longs, shorts, bytes, whatever. But you already know where it came from, and just want to know what's in the log
  XLogText = XLogText[25 : Len(Clip(XLogText))-1 ] !The very last byte is not a b64 byte, so we'll cut that off too.
  !if it GPFs on the next line, its probably because the XLog is > 30k after being decrypted. 
  ResultText = FromB64(XLogText)
  Display


!=============================================================================================================================================================
ReadFileToString       Procedure(String pFileName,*String pString)!,Long
!=============================================================================================================================================================
LOC:FileName   CString(File:MaxFilePath),Static
ReturnVal      Byte
FileBytes      Long,Auto
TargetBytes    Long,Auto
BytesRead      Long
RECORD_SIZE    Equate(8000h)

F    File,Driver('DOS'),PRE(F),Name(LOC:FileName),Create
Record  Record
S        String(RECORD_SIZE)
        end
     end

  Code

  pString = ''
  LOC:FileName = Clip(pFileName)
  If NOT Exists(LOC:FileName) OR NOT LOC:FileName
    Return 0
  end
  Open(F,40h) !Readonly+DenyNone
  If ErrorCode()
    Return 0
  end
  TargetBytes = Size(pString)
  FileBytes   = Bytes(F)
  If FileBytes > TargetBytes
    FileBytes = TargetBytes
  end
  Set(F)
  If FileBytes < RECORD_SIZE
    Next(F)
    pString[1 : FileBytes] = F.S[1 : FileBytes]
    Do ProcedureReturn
  end
  Loop BytesRead = 1 to FileBytes - FileBytes % RECORD_SIZE by RECORD_SIZE
    Next(F)
    If ErrorCode() then break.
    pString[BytesRead : BytesRead + RECORD_SIZE] = F.S
  end
  If BytesRead > 1 AND BytesRead < FileBytes
    Next(F)
    If NOT ErrorCode()
      pString[BytesRead  : FileBytes] = F.S[1 : FileBytes % RECORD_SIZE]
    end
  end
  Do ProcedureReturn


ProcedureReturn Routine
  Close(F)
  Return FileBytes

!=============================================================================================================================================================
FromB64  Procedure(String pIn)!,String
!=============================================================================================================================================================

L Long !Length
In  &CString
Out &CString
Ret ANY
RL Long !Return Length


  Code

  L = Len(Clip(pIN))
  Ret = ''
  If L
    In  &= NEW CString(L+1)
    Out &= NEW CString(L+1)
    In = pIn
    RL = CWdecode64(Out,In,L) - 1 !This is John Griffith's function http://sqlkey.com/base64encode.htm

    Ret = (Out[1 : RL])
    Dispose(In)
    Dispose(Out)
  end
  Return Ret

